      SUBROUTINE AFT1D(A,M,N,LOW,RCOND,Z,IERR)
C*********************************************************C
C   OEHKA CA OYCOBEHHOCT TPEYOHO MATP A.   C
C*********************************************************C
         INTEGER IERR,LOW,M,N
         DOUBLE PRECISION A,RCOND,Z
         DIMENSION A(M,1),Z(1)
         EXTERNAL UTAFSI
         INTEGER I,I0,I1,J,J0,J1,JJ,K,KB,LL,LM
         DOUBLE PRECISION ANORM,EK,S,SM,T,WK,WKM,X,YNORM
         LOGICAL LOWER
       RCOND = 0.0D0
C
C  YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH
       X = 0.0D0
   10  CONTINUE
C
C  POBEPKA PABHOCT AAH APAMETPOB M  N
       IF (N .GE. 1 .AND. M .GE. 1) GO TO 20
          IERR = 65
          CALL UTAFSI(1HA,1HF,1HT,1H1,1HD,IERR)
          GO TO 410
   20  CONTINUE
       IERR = 0
       LOWER = LOW .NE. 0
C
C  BCEHE 1-HOPM MATP A
       ANORM = 0.D0
       DO 70 J = 1, N
          T = 0.0D0
          I0 = 1
          IF (LOWER) I0 = J
          LM = J
          IF (LOWER) LM = N + 1 - J
          I1 = I0 + LM - 1
          I = MOD(LM,6) + I0 - 1
          IF (I .LT. I0) GO TO 40
             DO 30 JJ = I0, I
                T = T + DABS(A(JJ,J))
   30        CONTINUE
   40     CONTINUE
          I = I + 1
          IF (I .GT. I1) GO TO 60
             DO 50 JJ = I, I1, 6
                T = T + DABS(A(JJ,J)) + DABS(A(JJ+1,J)) + DABS(A(JJ+
     1              2,J)) + DABS(A(JJ+3,J)) + DABS(A(JJ+4,J)) +
     2              DABS(A(JJ+5,J))
   50        CONTINUE
   60     CONTINUE
          IF (T .GT. ANORM) ANORM = T
          IF (A(J,J) .EQ. 0.0D0) IERR = -J
   70  CONTINUE
       IF (IERR .EQ. 0) GO TO 80
          CALL UTAFSI(1HA,1HF,1HT,1H1,1HD,IERR)
          GO TO 410
   80  CONTINUE
C
C  BCEHE RCOND-BEH,OPATHO CY OYCOBEHHOCT MATP A.
C   BCEH HOPM MATP INVERSE(A) PEAETC CCTEMA A*Z=Y,
C  E Y-PEEHE CCTEM TRANS(A)*Y=E;KOMOHEHT BEKTOPA E BPATC
C  TAKM OPAOM,TO MAKCMPOBAT HOPMY BEKTOPA Y.
C
C  PEEHE CCTEM TRANS(A)*Y=E OHOBPEMEHHO C BOPOM E
       EK = 1.D0
       IF (N .GE. 2) GO TO 90
          RCOND = 1.0D0
   90  CONTINUE
       DO 100 J = 1, N
          Z(J) = 0.0D0
  100  CONTINUE
       DO 240 KB = 1, N
          K = KB
          IF (LOWER) K = N + 1 - KB
          IF (Z(K) .NE. 0.D0) EK = DSIGN(EK,-Z(K))
          IF (DABS(EK-Z(K)) .LE. DABS(A(K,K))) GO TO 170
             S = DABS(A(K,K))/DABS(EK-Z(K))
             ASSIGN 160 TO LL
  110     CONTINUE
          I = MOD(N,5)
          IF (I .EQ. 0) GO TO 130
             DO 120 JJ = 1, I
                Z(JJ) = S*Z(JJ)
  120        CONTINUE
             IF (N .LT. 5) GO TO 150
  130        CONTINUE
             I = I + 1
             DO 140 JJ = I, N, 5
                Z(JJ) = S*Z(JJ)
                Z(JJ+1) = S*Z(JJ+1)
                Z(JJ+2) = S*Z(JJ+2)
                Z(JJ+3) = S*Z(JJ+3)
                Z(JJ+4) = S*Z(JJ+4)
  140        CONTINUE
  150     CONTINUE
          GO TO LL,(160,310,320,400)
  160     CONTINUE
          EK = S*EK
  170     CONTINUE
          WK = EK - Z(K)
          WKM = -EK - Z(K)
          S = DABS(WK)
          SM = DABS(WKM)
          IF (A(K,K) .EQ. 0.0D0) GO TO 180
             WK = WK/A(K,K)
             WKM = WKM/A(K,K)
             GO TO 190
  180     CONTINUE
          WK = 1.D0
          WKM = 1.D0
  190     CONTINUE
          IF (KB .GE. N) GO TO 230
             J0 = K + 1
             IF (LOWER) J0 = 1
             J1 = N
             IF (LOWER) J1 = K - 1
             DO 200 J = J0, J1
                SM = SM + DABS(Z(J) + WKM*A(K,J))
                Z(J) = Z(J) + WK*A(K,J)
                S = S + DABS(Z(J))
  200        CONTINUE
             IF (S .GE. SM) GO TO 220
                T = WKM - WK
                WK = WKM
                DO 210 J = J0, J1
                   Z(J) = Z(J) + T*A(K,J)
  210           CONTINUE
  220        CONTINUE
  230     CONTINUE
          Z(K) = WK
  240  CONTINUE
       ASSIGN 300 TO LL
  250  CONTINUE
       S = 0.0D0
       I = MOD(N,6)
       IF (I .EQ. 0) GO TO 270
          DO 260 JJ = 1, I
             S = S + DABS(Z(JJ))
  260     CONTINUE
          IF (N .LT. 6) GO TO 290
  270     CONTINUE
          I = I + 1
          DO 280 JJ = I, N, 6
             S = S + DABS(Z(JJ)) + DABS(Z(JJ+1)) + DABS(Z(JJ+2)) +
     1           DABS(Z(JJ+3)) + DABS(Z(JJ+4)) + DABS(Z(JJ+5))
  280     CONTINUE
  290  CONTINUE
       S = 1.0D0/S
       GO TO LL,(300,390)
  300  CONTINUE
       ASSIGN 310 TO LL
       GO TO 110
  310  CONTINUE
       YNORM = 1.D0
C
C  PEEHE CCTEM A*Z=Y
       DO 380 KB = 1, N
          K = N + 1 - KB
          IF (LOWER) K = KB
          IF (DABS(Z(K)) .LE. DABS(A(K,K))) GO TO 330
             S = DABS(A(K,K))/DABS(Z(K))
             ASSIGN 320 TO LL
             GO TO 110
  320     CONTINUE
          YNORM = S*YNORM
  330     CONTINUE
          IF (A(K,K) .NE. 0.D0) Z(K) = Z(K)/A(K,K)
          IF (A(K,K) .EQ. 0.D0) Z(K) = 1.D0
          IF (KB .GE. N) GO TO 370
             I0 = 1
             IF (LOWER) I0 = K + 1
             LM = N - KB
             I1 = I0 + LM - 1
             T = -Z(K)
             I = MOD(LM,4) + I0 - 1
             IF (I .LT. I0) GO TO 350
                DO 340 JJ = I0, I
                   Z(JJ) = Z(JJ) + T*A(JJ,K)
  340           CONTINUE
  350        CONTINUE
             I = I + 1
             IF (I .GT. I1) GO TO 370
                DO 360 JJ = I, I1, 4
                   Z(JJ) = Z(JJ) + T*A(JJ,K)
                   Z(JJ+1) = Z(JJ+1) + T*A(JJ+1,K)
                   Z(JJ+2) = Z(JJ+2) + T*A(JJ+2,K)
                   Z(JJ+3) = Z(JJ+3) + T*A(JJ+3,K)
  360           CONTINUE
  370        CONTINUE
  380     CONTINUE
          ASSIGN 390 TO LL
          GO TO 250
  390  CONTINUE
       ASSIGN 400 TO LL
       GO TO 110
  400  CONTINUE
       YNORM = S*YNORM
       IF (ANORM .NE. 0.D0) RCOND = YNORM/ANORM
  410  CONTINUE
       RETURN
      END
